/* (C) 2009-2010 Yana */

#if !defined(YK0A_ARM_H)
#define YK0A_ARM_H

#include "yk0a_base.h"

#define YK0A_ARM_CPSR_I (1 << 7)
#define YK0A_ARM_CPSR_F (1 << 6)
#define YK0A_ARM_CPSR_M_MASK (0x1f << YK0A_ARM_CPSR_M_SHIFT)
#define YK0A_ARM_CPSR_M_SHIFT 0

#define YK0A_ARM_CPSR_M_IRQ (0x12 << YK0A_ARM_CPSR_M_SHIFT)
#define YK0A_ARM_CPSR_M_SVC (0x13 << YK0A_ARM_CPSR_M_SHIFT)
#define YK0A_ARM_CPSR_M_SYS (0x1f << YK0A_ARM_CPSR_M_SHIFT)

#if !defined(YK0A_PREPROCESS_ONLY)

__inline__ static yk0a_uint32_t yk0a_arm_read_cpsr(void) {
	yk0a_uint32_t cpsr;
	__asm__ __volatile__("mrs %0, cpsr" : "=r"(cpsr));
	return cpsr;
}

__inline__ static void yk0a_arm_write_cpsr(yk0a_uint32_t cpsr) {
	__asm__ __volatile__("msr cpsr, %0" : : "r"(cpsr) : "cc");
}

#endif

#endif
