/* (C) 2009-2010 Yana */

#if !defined(YK0A_INTERNAL_H)
#define YK0A_INTERNAL_H

#include "yk0a_base.h"

#define YK0A_CONTEXT_BASE 8
#define YK0A_CONTEXT_SIZE 18

#define YK0A_INTERRUPT_ADDRESS_STATUS 0x16000000
#define YK0A_INTERRUPT_ADDRESS_MASK 0x16000004
#define YK0A_INTERRUPT_ADDRESS_UNMASK 0x16000008
#define YK0A_INTERRUPT_SIZE 32

#define YK0A_STATE_READY 0
#define YK0A_STATE_RECEIVE 1
#define YK0A_STATE_REPLY 2
#define YK0A_STATE_SEND 3

#if !defined(YK0A_PREPROCESS_ONLY)

extern yk0a_uint32_t yk0a_interrupt_mask;

__inline__ static yk0a_uint32_t yk0a_interrupt_read_mask(void) {
	return yk0a_interrupt_mask;
}

__inline__ static yk0a_uint32_t yk0a_interrupt_read_request(void) {
	return *(volatile yk0a_uint32_t *)YK0A_INTERRUPT_ADDRESS_STATUS;
}

__inline__ static void yk0a_interrupt_write_mask(yk0a_uint32_t mask) {
	yk0a_uint32_t i;
	for (i = 0; i < YK0A_INTERRUPT_SIZE; ++i) {
		if ((yk0a_interrupt_mask & 1 << i) != (mask & 1 << i)) {
			if ((mask & 1 << i) == 0) {
				*(volatile yk0a_uint32_t *)YK0A_INTERRUPT_ADDRESS_MASK = i;
			} else {
				*(volatile yk0a_uint32_t *)YK0A_INTERRUPT_ADDRESS_UNMASK = i;
			}
		}
	}
	yk0a_interrupt_mask = mask;
}

__inline__ static void yk0a_interrupt_write_request(yk0a_uint32_t request) {
}

__inline__ static void yk0a_interrupt_initialize(void) {
	yk0a_interrupt_mask = ~0;
	yk0a_interrupt_write_mask(0);
}

#endif

#endif
