/* (C) 2009-2010 Yana */

#if !defined(YK0A_MIPS_H)
#define YK0A_MIPS_H

#include "yk0a_base.h"

#define YK0A_MIPS_STATUS $12
#define YK0A_MIPS_CAUSE $13
#define YK0A_MIPS_EPC $14

#define YK0A_MIPS_HAZARD_STATUS ssnop; ssnop
#define YK0A_MIPS_HAZARD_CAUSE ssnop
#define YK0A_MIPS_HAZARD_EPC

#define YK0A_MIPS_STATUS_BEV (1 << 22)
#define YK0A_MIPS_STATUS_IM_MASK (0xff << YK0A_MIPS_STATUS_IM_SHIFT)
#define YK0A_MIPS_STATUS_IM_SHIFT 8
#define YK0A_MIPS_STATUS_KSU_MASK (3 << YK0A_MIPS_STATUS_KSU_SHIFT)
#define YK0A_MIPS_STATUS_KSU_SHIFT 3
#define YK0A_MIPS_STATUS_ERL (1 << 2)
#define YK0A_MIPS_STATUS_EXL (1 << 1)
#define YK0A_MIPS_STATUS_IE (1 << 0)

#define YK0A_MIPS_CAUSE_BD (1 << 31)
#define YK0A_MIPS_CAUSE_IV (1 << 23)
#define YK0A_MIPS_CAUSE_IP_MASK (0xff << YK0A_MIPS_CAUSE_IP_SHIFT)
#define YK0A_MIPS_CAUSE_IP_SHIFT 8
#define YK0A_MIPS_CAUSE_EXCCODE_MASK (0x1f << YK0A_MIPS_CAUSE_EXCCODE_SHIFT)
#define YK0A_MIPS_CAUSE_EXCCODE_SHIFT 2

#define YK0A_MIPS_CAUSE_EXCCODE_INT (0x00 << YK0A_MIPS_CAUSE_EXCCODE_SHIFT)
#define YK0A_MIPS_CAUSE_EXCCODE_SYS (0x08 << YK0A_MIPS_CAUSE_EXCCODE_SHIFT)

#if !defined(YK0A_PREPROCESS_ONLY)

__inline__ static yk0a_uint32_t yk0a_mips_read_cause(void) {
	yk0a_uint32_t cause;
	__asm__ __volatile__("mfc0 %0, " YK0A_PREPROCESS_STRING(YK0A_MIPS_CAUSE) : "=r"(cause));
	return cause;
}

__inline__ static yk0a_uint32_t yk0a_mips_read_status(void) {
	yk0a_uint32_t status;
	__asm__ __volatile__("mfc0 %0, " YK0A_PREPROCESS_STRING(YK0A_MIPS_STATUS) : "=r"(status));
	return status;
}

__inline__ static void yk0a_mips_write_cause(yk0a_uint32_t cause) {
	__asm__ __volatile__("mtc0 %0, " YK0A_PREPROCESS_STRING(YK0A_MIPS_CAUSE) "; " YK0A_PREPROCESS_STRING(YK0A_MIPS_HAZARD_CAUSE) : : "r"(cause));
}

__inline__ static void yk0a_mips_write_status(yk0a_uint32_t status) {
	__asm__ __volatile__("mtc0 %0, " YK0A_PREPROCESS_STRING(YK0A_MIPS_STATUS) "; " YK0A_PREPROCESS_STRING(YK0A_MIPS_HAZARD_STATUS) : : "r"(status));
}

#endif

#endif
