/* (C) 2009-2010 Yana */

#if !defined(DEVICE_H)
#define DEVICE_H

#if defined(TESTMIPS32)
#define DEVICE_BASE 0xa0000000
#elif defined(TESTMIPS64)
#define DEVICE_BASE 0xffffffffa0000000
#else
#define DEVICE_BASE 0
#endif

#define DEVICE_CONS_PUTGETCHAR (DEVICE_BASE + 0x10000000)
#define DEVICE_CONS_HALT (DEVICE_BASE + 0x10000010)

#define DEVICE_DISK_OFFSET (DEVICE_BASE + 0x13000000)
#define DEVICE_DISK_OFFSET_HIGH32 (DEVICE_BASE + 0x13000008)
#define DEVICE_DISK_ID (DEVICE_BASE + 0x13000010)
#define DEVICE_DISK_START_OPERATION (DEVICE_BASE + 0x13000020)
#define DEVICE_DISK_STATUS (DEVICE_BASE + 0x13000030)
#define DEVICE_DISK_BUFFER (DEVICE_BASE + 0x13004000)

#define DEVICE_DISK_BUFFER_LEN 0x200

#define DEVICE_DISK_OPERATION_READ 0
#define DEVICE_DISK_OPERATION_WRITE 1

#define DEVICE_ETHER_BUFFER (DEVICE_BASE + 0x14000000)
#define DEVICE_ETHER_STATUS (DEVICE_BASE + 0x14004000)
#define DEVICE_ETHER_PACKETLENGTH (DEVICE_BASE + 0x14004010)
#define DEVICE_ETHER_COMMAND (DEVICE_BASE + 0x14004020)

#define DEVICE_ETHER_BUFFER_SIZE 0x4000

#define DEVICE_ETHER_STATUS_MORE_PACKETS_AVAILABLE (1 << 1)
#define DEVICE_ETHER_STATUS_PACKET_RECEIVED (1 << 0)

#define DEVICE_ETHER_COMMAND_RX 0
#define DEVICE_ETHER_COMMAND_TX 1

#define DEVICE_RTC_TRIGGER_READ (DEVICE_BASE + 0x15000000)
#define DEVICE_RTC_SEC (DEVICE_BASE + 0x15000010)
#define DEVICE_RTC_USEC (DEVICE_BASE + 0x15000020)
#define DEVICE_RTC_HZ (DEVICE_BASE + 0x15000100)
#define DEVICE_RTC_INTERRUPT_ACK (DEVICE_BASE + 0x15000110)

#define DEVICE_INTERRUPT_RTC (1 << 4)
#define DEVICE_INTERRUPT_ETHER (1 << 3)
#define DEVICE_INTERRUPT_CONS (1 << 2)

__inline__ static unsigned char device_cons_getchar(void) {
	return *(volatile unsigned char *)DEVICE_CONS_PUTGETCHAR;
}

__inline__ static void device_cons_halt(void) {
	*(volatile unsigned char *)DEVICE_CONS_HALT;
}

__inline__ static void device_cons_putchar(unsigned char c) {
	*(volatile unsigned char *)DEVICE_CONS_PUTGETCHAR = c;
}

#endif
