/* (C) 2009-2010 Yana */

#include "tool.h"
#include "device.h"
#include "yk0a.h"
#include "yk0a_arm.h"
#include <stddef.h>

void tool_cons_put_hexadecimal(yk0a_uint32_t hexadecimal) {
	yk0a_uint32_t i;
	for (i = 0; i < 8; ++i) {
		device_cons_putchar("0123456789abcdef"[hexadecimal >> (28 - i * 4) & 0xf]);
	}
}

void tool_cons_put_string(const char *string) {
	while (*string != 0) {
		device_cons_putchar(*string);
		++string;
	}
}

void tool_task_start(yk0a_task_t task, void (*pc)(void), void *sp) {
	yk0a_set_context(task, YK0A_CONTEXT_R13, (yk0a_uint32_t)sp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_R14, (yk0a_uint32_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_R15, (yk0a_uint32_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_SPSR, yk0a_arm_read_cpsr(), NULL);
	yk0a_set_context(task, YK0A_CONTEXT_CPSR, 0, NULL);
	yk0a_reply(task);
}
