/* (C) 2009-2010 Yana */

#include "device.h"
#include "start_setup.h"
#include "tool.h"
#include "yk0a.h"
#include "yk0a_interrupt.h"
#include "yk0a_setup.h"

yk0a_uint8_t task0_stack[TASK0_STACK_SIZE] __attribute__((aligned(YK0A_STACK_ALIGN)));
yk0a_uint8_t task1_stack[TASK1_STACK_SIZE] __attribute__((aligned(YK0A_STACK_ALIGN)));

void task1(void);

void task0(void) {
	yk0a_flag_t f;
	yk0a_task_t t;
	tool_task_start(1, task1, task1_stack + TASK1_STACK_SIZE / YK0A_STACK_ALIGN * YK0A_STACK_ALIGN);
	yk0a_listen(YK0A_SETUP_EXCEPTION_PORT, ~YK0A_FLAG_KERNEL_RECEIVER, &f);
	tool_cons_put_string("{");
	tool_cons_put_hexadecimal(f);
	if ((f & YK0A_FLAG_KERNEL_SENDER) != 0 && yk0a_accept(YK0A_SETUP_EXCEPTION_PORT, &t) == 0) {
		yk0a_uint32_t cpsr;
		yk0a_get_context(t, YK0A_CONTEXT_CPSR, &cpsr);
		tool_cons_put_string(" ");
		tool_cons_put_hexadecimal(t);
		tool_cons_put_string(" ");
		tool_cons_put_hexadecimal(cpsr);
	}
	tool_cons_put_string("}\n");
	device_cons_halt();
}

void task1(void) {
	while (1) {
		yk0a_interrupt_t i;
		yk0a_interrupt_bit_request(0, 0, &i);
		if ((i & DEVICE_INTERRUPT_CONS) != 0) {
			yk0a_uint8_t c;
			c = device_cons_getchar();
			if (c < ' ') {
				break;
			}
			device_cons_putchar(c);
		}
	}
	__asm__ __volatile__(".word 0xe1200070"); /* bkpt */
}
