/* (C) 2009-2010 Yana */

#define YK0A_PREPROCESS_ONLY
#include "start_setup.h"
#include "yk0a_mips.h"

#define CAUSE_OFF YK0A_MIPS_CAUSE_IV
#define CAUSE_ON 0
#define STATUS_OFF (YK0A_MIPS_STATUS_BEV | YK0A_MIPS_STATUS_KSU_MASK | YK0A_MIPS_STATUS_ERL)
#define STATUS_ON (YK0A_MIPS_STATUS_EXL | YK0A_MIPS_STATUS_IE)

#define VECTOR_TLB_FROM vector
#define VECTOR_TLB_SIZE 0x10
#define VECTOR_TLB_TO (0x80000000 | 0xa0000000)
#define VECTOR_OTHER_FROM vector
#define VECTOR_OTHER_SIZE 0x10
#define VECTOR_OTHER_TO (0x80000180 | 0xa0000000)

	.macro VECTOR_COPY from, size, to
	.set push
	.set reorder
	la $2, \from
	la $3, \to
	la $4, \from+\size
0:
	lw $5, ($2)
	sw $5, ($3)
	addiu $2, $2, 4
	addiu $3, $3, 4
	bne $2, $4, 0b
	.set pop
	.endm

	.set at
	.set reorder

	.text
	.balign 4

vector:
	.set noat
	la $kt0, yk0a_exception_interrupt_procedure
	jr $kt0
	.set at

	.global start
start:
	mfc0 $2, YK0A_MIPS_CAUSE
	li $3, ~CAUSE_OFF
	and $2, $2, $3
	li $3, CAUSE_ON
	or $2, $2, $3
	mtc0 $2, YK0A_MIPS_CAUSE
	YK0A_MIPS_HAZARD_CAUSE

	mfc0 $2, YK0A_MIPS_STATUS
	li $3, ~STATUS_OFF
	and $2, $2, $3
	li $3, STATUS_ON
	or $2, $2, $3
	mtc0 $2, YK0A_MIPS_STATUS
	YK0A_MIPS_HAZARD_STATUS

	VECTOR_COPY VECTOR_TLB_FROM, VECTOR_TLB_SIZE, VECTOR_TLB_TO
	VECTOR_COPY VECTOR_OTHER_FROM, VECTOR_OTHER_SIZE, VECTOR_OTHER_TO

	la $2, yk0a_initialize
	jalr $2

	la $gp, _gp
	la $sp, START_SETUP_TASK0_SP
	la $ra, START_SETUP_TASK0_PC
	mtc0 $ra, YK0A_MIPS_EPC
	YK0A_MIPS_HAZARD_EPC
	eret
