/* (C) 2009-2010 Yana */

#include "tool.h"
#include "device.h"
#include "yk0a.h"
#include "yk0a_mips.h"
#include <stddef.h>

void tool_cons_put_hexadecimal(yk0a_uint32_t hexadecimal) {
	yk0a_uint32_t i;
	for (i = 0; i < 8; ++i) {
		device_cons_putchar("0123456789abcdef"[hexadecimal >> (28 - i * 4) & 0xf]);
	}
}

void tool_cons_put_string(const char *string) {
	while (*string != 0) {
		device_cons_putchar(*string);
		++string;
	}
}

void tool_task_start(yk0a_task_t task, void (*pc)(void), void *sp) {
	register yk0a_uint32_t gp __asm__("$28");
	yk0a_set_context(task, YK0A_CONTEXT_GPR28, gp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_GPR29, (yk0a_uint32_t)sp, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_GPR31, (yk0a_uint32_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_EPC, (yk0a_uint32_t)pc, NULL);
	yk0a_set_context(task, YK0A_CONTEXT_STATUS, yk0a_mips_read_status(), NULL);
	yk0a_set_context(task, YK0A_CONTEXT_CAUSE, 0, NULL);
	yk0a_reply(task);
}
