/* (C) 2009-2010 Yana */

#if !defined(TOOL_H)
#define TOOL_H

#include "yk0a.h"

#if !defined(YK0A_PREPROCESS_ONLY)

#include <stddef.h>

typedef struct tool_queue {
	struct tool_queue *next;
	struct tool_queue *previous;
} tool_queue_t;

__inline__ static void tool_queue_append(tool_queue_t *root, tool_queue_t *node) {
	node->next = root;
	node->previous = root->previous;
	root->previous->next = node;
	root->previous = node;
}

__inline__ static tool_queue_t *tool_queue_copy(tool_queue_t *root) {
	if (root->next == root) {
		return NULL;
	} else {
		return root->next;
	}
}

__inline__ static void tool_queue_delete(tool_queue_t *node) {
	node->next->previous = node->previous;
	node->previous->next = node->next;
}

__inline__ static void tool_queue_initialize(tool_queue_t *root) {
	root->next = root;
	root->previous = root;
}

__inline__ static tool_queue_t *tool_queue_remove(tool_queue_t *root) {
	if (root->next == root) {
		return NULL;
	} else {
		tool_queue_t *node;
		node = root->next;
		root->next = node->next;
		node->next->previous = node->previous;
		return node;
	}
}

void tool_cons_put_hexadecimal(yk0a_uint32_t hexadecimal);

void tool_cons_put_string(const char *string);

void tool_task_start(yk0a_task_t task, void (*pc)(void), void *sp);

#endif

#endif
